import java.io.*;
import java.util.*;

public class B {

    public static final int MOD = (int) (1e9 + 7);

    public int[][][] cache;

    public int dp(int sum, int prev, int up) {
        if (sum == 0) {
            return 1;
        }
        if (sum < 0) {
            return 0;
        }
        if (cache[sum][prev][up] != -1)
            return cache[sum][prev][up];
        int ans = 0;
        if (up == 1) {
            for (int cur = prev + 1; cur <= sum; cur++) {
                ans += dp(sum - cur, cur, 1 - up);
                ans %= MOD;
            }
        } else {
            for (int cur = 1; cur < prev; cur++) {
                ans += dp(sum - cur, cur, 1 - up);
                ans %= MOD;
            }
        }
        cache[sum][prev][up] = ans;
        return ans;
    }

    public void solve() throws IOException {
        int n = nextInt();
        int k = nextInt();
        if (n == k) {
            out.print(1);
            return;
        }
        cache = new int[n + 1][n + 1][2];
        for (int i = 0; i < n + 1; i++) {
            for (int j = 0; j < n + 1; j++) {
                Arrays.fill(cache[i][j], -1);
            }
        }
        out.print(dp(n - k, k, 1) + dp(n - k, k, 0));
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }

}