import java.io.*;
import java.util.*;

public class BFast {

    public static final int MOD = (int) (1e9 + 7);

    public void solve() throws IOException {
        int n = nextInt();
        int k = nextInt();
        if (n == k) {
            out.print(1);
            return;
        }
        int[][][] dp = new int[n + 1][n + 1][2];
        for (int prev = 0; prev < n + 1; prev++) {
            Arrays.fill(dp[0][prev], 1);
        }
        int[] pref0 = new int[n + 2];
        int[] suff1 = new int[n + 2];
        for (int sum = 1; sum <= n; sum++) {
            for (int prev = 1; prev <= n; prev++) {
                pref0[prev] = pref0[prev - 1];
                if (sum - prev >= 0) {
                    pref0[prev] = (pref0[prev] + dp[sum - prev][prev][1]) % MOD;
                }
            }
            for (int prev = n; prev >= 1; prev--) {
                suff1[prev] = suff1[prev + 1];
                if (sum - prev >= 0) {
                    suff1[prev] = (suff1[prev] + dp[sum - prev][prev][0]) % MOD;
                }
            }
            for (int prev = 1; prev <= n; prev++) {
                dp[sum][prev][0] += pref0[prev - 1];
                dp[sum][prev][0] %= MOD;
            }
            for (int prev = 1; prev <= n; prev++) {
                dp[sum][prev][1] += suff1[prev + 1];
                dp[sum][prev][1] %= MOD;
            }
        }
        out.print((dp[n - k][k][1] + dp[n - k][k][0]) % MOD);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new BFast().run();
    }

}