import java.io.*;
import java.util.*;

public class CSlow {


    public List<List<Integer>> g;
    public int[] dp1;
    public int[] dp0;
    public int[] color;

    public void dfs(int v, int p) {
        color[v] = 1;
        for (int i = 0; i < g.get(v).size(); i++) {
            int u = g.get(v).get(i);
            if (u != p)
                dfs(u, v);
        }
        dp1[v] = 1;
        for (int i = 0; i < g.get(v).size(); i++) {
            int u = g.get(v).get(i);
            dp1[v] += dp0[u];
        }
        for (int i = 0; i < g.get(v).size(); i++) {
            int u = g.get(v).get(i);
            dp0[v] += Math.max(dp0[u], dp1[u]);
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        g = new ArrayList<List<Integer>>(n);
        for (int i = 0; i < n; i++) {
            g.add(new ArrayList<Integer>());
        }
        boolean group3 = true;
        boolean prev = true;
        for (int i = 0; i < n; i++) {
            int to = nextInt() - 1;
            if (to > i) {
                group3 = false;
            }
            if (i > 0 && to != i - 1) {
                prev = false;
            }
            if (i == 0 && to != -2) {
                prev = false;
            }
            if (to >= 0) {
                g.get(i).add(to);
                g.get(to).add(i);
            }
        }

        boolean group2 = prev;
        if (n <= 20) {
            int ans = 0;
            List<Set<Integer>> gSet = new ArrayList<Set<Integer>>(n);
            for (int i = 0; i < n; i++) {
                gSet.add(new TreeSet<Integer>(g.get(i)));
            }
            for (int curMask = 0; curMask < (1 << n); curMask++) {
                boolean valid = true;
                List<Integer> cur = new ArrayList<Integer>();
                for (int j = 0; j < n; j++) {
                    if (((curMask >> j) & 1) == 1) {
                        cur.add(j);
                    }
                }
                for (int i = 0; i < cur.size(); i++) {
                    if (!valid) {
                        break;
                    }
                    for (int k = 0; k < cur.size(); k++) {
                        int v = cur.get(i);
                        int u = cur.get(k);
                        if (gSet.get(v).contains(u)) {
                            valid = false;
                            break;
                        }
                    }
                }
                if (valid) {
                    ans = Math.max(ans, Integer.bitCount(curMask));
                }
            }
            out.print(ans);
            return;
        }
        if (group2) {
            out.print((n + 1) / 2);
            return;
        }
        if (group3) {
            dp1 = new int[n];
            dp0 = new int[n];
            color = new int[n];
            int ans = 0;
            for (int i = 0; i < n; i++) {
                if (color[i] == 0) {
                    dfs(i, -1);
                    ans += Math.max(dp0[i], dp1[i]);
                }
            }
            out.print(ans);
            return;
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new CSlow().run();
    }

}