import java.io.*;
import java.util.*;

public class C {

    public List<List<Integer>> g;
    public int color[];

    public void dfs(int v, boolean can) {
        for (int i = 0; i < g.get(v).size(); i++) {
            int u = g.get(v).get(i);
            if (color[u] == 1) {
                can = false;
            }
        }
        if (can) {
            color[v] = 1;
        } else {
            color[v] = 0;
        }
        for (int i = 0; i < g.get(v).size(); i++) {
            int u = g.get(v).get(i);
            if (color[u] == -1) {
                dfs(u, !can);
            }
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        g = new ArrayList<List<Integer>>(n);
        for (int i = 0; i < n; i++) {
            g.add(new ArrayList<Integer>());
        }
        for (int i = 0; i < n; i++) {
            int to = nextInt() - 1;
            if (to >= 0) {
                g.get(i).add(to);
                g.get(to).add(i);
            }
        }
        int ans = 0;
        color = new int[n];
        for (int i = 0; i < n; i++) {
            Arrays.fill(color, -1);
            dfs(i, true);
            int curAns = 0;
            for (int j = 0; j < n; j++) {
                if (color[j] == 1) {
                    curAns++;
                }
            }
            ans = Math.max(ans, curAns);
            Arrays.fill(color, -1);
            dfs(i, false);
            curAns = 0;
            for (int j = 0; j < n; j++) {
                if (color[j] == 1) {
                    curAns++;
                }
            }
            ans = Math.max(ans, curAns);
        }
        out.print(ans);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new C().run();
    }

}