import java.io.*;
import java.util.*;

public class C {

    public List<List<Integer>> g;
    public int[] color;
    public boolean haveCycle = false;
    public int cycleV = -1;

    public int[] par;
    public boolean[] cycled;

    public void dfs(int v, int p) {
        color[v] = 1;
        par[v] = p;
        for (int i = 0; i < g.get(v).size(); i++) {
            int u = g.get(v).get(i);
            if (color[u] == -1) {
                dfs(u, v);
            } else if (u != p && color[u] == 1) {
                haveCycle = true;
                cycleV = v;
            }
        }
        color[v] = 2;
    }

    public int sz = 0;

    public void dfs2(int v) {
        if (cycled[v]) {
            return;
        }
        sz++;
        color[v] = 1;
        for (int i = 0; i < g.get(v).size(); i++) {
            int u = g.get(v).get(i);
            if (color[u] == -1) {
                dfs2(u);
            }
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        g = new ArrayList<List<Integer>>(n);
        for (int i = 0; i < n; i++) {
            g.add(new ArrayList<Integer>());
        }
        for (int i = 0; i < n; i++) {
            int to = nextInt() - 1;
            if (to >= 0) {
                g.get(i).add(to);
                g.get(to).add(i);
            }
        }
        color = new int[n];
        par = new int[n];
        cycled = new boolean[n];
        Arrays.fill(color, -1);
        int ans = 0;
        for (int i = 0; i < n; i++) {
            if (color[i] == -1) {
                haveCycle = false;
                sz = 0;
                dfs(i, -1);
                if (haveCycle) {
                    int start = cycleV;
                    int sz = 0;
                    while (start != -1) {
                        cycled[start] = true;
                        sz++;
                        start = par[start];
                    }
                    ans += sz / 2;
                }
            }
        }
        Arrays.fill(color, -1);
        for (int i = 0; i < n; i++) {
            if (color[i] == -1) {
                sz = 0;
                dfs2(i);
                ans += (sz + 1) / 2;
            }
        }
        out.print(ans);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new C().run();
    }

}