import java.io.*;
import java.util.*;

public class D2 {

    public int[][] params;

    public int[] pair;
    public boolean[] used;
    public int n, k;

    public static class Segment {
        public int l, r;

        public Segment(int l, int r) {
            this.l = l;
            this.r = r;
        }
    }

    public Segment intersect(Segment a, Segment b) {
        return new Segment(Math.max(a.l, b.l), Math.min(b.r, a.r));
    }


    public void gen(int pos) {
        if (pos == pair.length) {
            Segment[] segments = new Segment[k];
            for (int i = 0; i < k; i++) {
                segments[i] = new Segment(Integer.MIN_VALUE, Integer.MAX_VALUE);
            }
            for (int i = 0; i < n / 2; i++) {
                int v = i;
                int u = pair[v];
                for (int j = 0; j < k; j++) {
                    int l = Math.min(params[v][j], params[u][j]);
                    int r = Math.max(params[v][j], params[u][j]);
                    segments[j] = intersect(segments[j], new Segment(l, r));
                    if (segments[j].l > segments[j].r) {
                        return;
                    }
                }
            }
            boolean can = true;
            for (int i = 0; i < k; i++) {
                if (!(segments[i].l <= segments[i].r)) {
                    can = false;
                }
            }
            if (can) {
                out.println("YES");
                for (int i = 0; i < n / 2; i++) {
                    out.print(i + 1);
                    out.print(' ');
                    out.println(pair[i] + 1);
                }
                out.close();
                System.exit(0);
            }
        } else {
            for (int cur = n / 2; cur < n; cur++) {
                if (used[cur])
                    continue;
                used[cur] = true;
                pair[pos] = cur;
                gen(pos + 1);
                used[cur] = false;
            }
        }
    }

    public static class Pair implements Comparable<Pair> {
        public int x, ind;

        public Pair(int x, int ind) {
            this.x = x;
            this.ind = ind;
        }

        @Override
        public int compareTo(Pair p) {
            return Integer.compare(x, p.x);
        }
    }

    public void solve() throws IOException {
        n = nextInt();
        k = nextInt();
        params = new int[n][k];
        pair = new int[n / 2];
        used = new boolean[n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < k; j++) {
                params[i][j] = nextInt();
            }
        }
        if (k > 1) {
            gen(0);
            out.print("NO");
        } else {
            Pair[] pairs = new Pair[n];
            for (int i = 0; i < n; i++) {
                pairs[i] = new Pair(params[i][0], i);
            }
            Arrays.sort(pairs);
            out.println("YES");
            for (int i = 0; i < n / 2; i++) {
                Pair p1 = pairs[i];
                Pair p2 = pairs[n - 1 - i];
                out.print(p1.ind + 1);
                out.print(' ');
                out.println(p2.ind + 1);
            }
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D2().run();
    }

}